package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRAttendance;
import cn.ibizlab.humanresource.core.humanresource.filter.HRAttendanceSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRAttendance] 服务对象接口
 */
public interface IHRAttendanceService extends IService<HRAttendance>{

    boolean create(HRAttendance et) ;
    void createBatch(List<HRAttendance> list) ;
    boolean update(HRAttendance et) ;
    void updateBatch(List<HRAttendance> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRAttendance get(String key) ;
    HRAttendance getDraft(HRAttendance et) ;
    boolean checkKey(HRAttendance et) ;
    boolean save(HRAttendance et) ;
    void saveBatch(List<HRAttendance> list) ;
    Page<HRAttendance> searchDefault(HRAttendanceSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRAttendance> getHrattendanceByIds(List<String> ids) ;
    List<HRAttendance> getHrattendanceByEntities(List<HRAttendance> entities) ;
}


